/*#######################################################################################
AVR DCF77 Clock

Copyright (C) 2005 Ulrich Radig

#######################################################################################*/

#ifndef _CLOCK_H
 #define _CLOCK_H

//Signal dauer auswertung
#define count_res   42099 //Berechnet aus 65536-(1.2s*Quarzfrequenz/1024)

#define low_min		42880 // count_res + (80ms*Quarzfrequenz/1024)
#define low_max		44442 // count_res + (120ms*Quarzfrequenz/1024)
#define hi_min		43974 // count_res + (180ms*Quarzfrequenz/1024)
#define hi_max		46005 // count_res + (220ms*Quarzfrequenz/1024)


extern unsigned char ss;	//Globale Variable fr Sekunden
extern unsigned char mm;	//Globale Variable fr Minuten
extern unsigned char hh;	//Globale Variable fr Stunden
extern unsigned char day;	//Globale Variable fr den Tag
extern unsigned char mon;	//Globale Variable fr den Monat
extern unsigned int year;	//Globale Variable fr den Jahr

extern void Start_Clock (void); //Startet die DCF77 Uhr

//64 Bit fr DCF77 bentigt werden 59 Bits
extern unsigned long long dcf_rx_buffer;
//RX Pointer (Counter)
extern unsigned char rx_bit_counter;

//Interrupt an dem das DCF77 Modul hngt hier INT0
#define DCF77_INT_ENABLE()	GIMSK = (1<<INT0);
#define DCF77_INT			SIG_INTERRUPT0

#define INT0_CONTROL		MCUCR
#define INT0_FALLING_EDGE	((1<<ISC01)|(0<<ISC00))
#define INT0_RISING_EDGE	((1<<ISC01)|(1<<ISC00))

//Structur des dcf_rx_buffer
struct  DCF77_Bits {
	uint64_t M			:1	;//Minutenmarke
	uint64_t O1			:1	;
	uint64_t O2			:1	;
	uint64_t O3			:1	;
	uint64_t O4			:1	;
	uint64_t O5			:1	;
	uint64_t O6			:1	;
	uint64_t O7			:1	;
	uint64_t O8			:1	;
	uint64_t O9			:1	;
	uint64_t O10		:1	;
	uint64_t O11		:1	;
	uint64_t O12		:1	;
	uint64_t O13		:1	;
	uint64_t O14		:1	;
	uint64_t R			:1	; 	// 0 = Betriebsantenne 1=Reserveantenne
	uint64_t A1			:1	; 	// 1= Wenn wechsel von Sommer auf winter zeit oder zurck
	uint64_t Z1			:1	; 	// 1= Wenn Sommerzeit sonst =0
	uint64_t Z2			:1	; 	// 1= Wenn Winterzeit sonst =0
	uint64_t A2			:1	; 	// 1= Wenn Schaltsekunde
	uint64_t S			:1	; 	// 1= Startbit fr Zeitinformation
	uint64_t Min		:7	;		//7 Bits fr die Minuten
	uint64_t P1			:1;		//Parity Minuten
	uint64_t Hour		:6	;		//6 Bits fr die Stunden
	uint64_t P2			:1;		//Parity Stunden
	uint64_t Day		:6	;		//6 Bits fr den Tag
	uint64_t Weekday	:3	;		//3 Bits fr den Wochentag 
	uint64_t Month		:5	;		//3 Bits fr den Monat
	uint64_t Year		:8	;		//8 Bits fr das Jahr **eine 5 fr das Jahr 2005**
	uint64_t P3			:1;		//Parity von P2
	};
	
struct 
	{
	char parity_err					:1	;//Hilfs Parity
	char parity_P1					:1	;//Berechnetes Parity P1
	char parity_P2					:1	;//Berechnetes Parity P2
	char parity_P3					:1	;//Berechnetes Parity P3
	char dcf_rx						:1	;//Es wurde ein Impuls empfangen
	char dcf_allsync				:1	;//Es wurde ein Impuls empfangen		
	char dcf_sync					:1	;//In der letzten Minuten wurde die Uhr syncronisiert
	}flags;
	
#endif //_CLOCK_H
